#![allow(deprecated)]
use std::fmt;
use std::str;
/// Aggregations for enum series in multivariate queries.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum EnumMultivariateAggregation {
    #[serde(rename = "MODE")]
    Mode,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl EnumMultivariateAggregation {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            EnumMultivariateAggregation::Mode => "MODE",
            EnumMultivariateAggregation::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for EnumMultivariateAggregation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for EnumMultivariateAggregation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for EnumMultivariateAggregation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<EnumMultivariateAggregation, conjure_object::plain::ParseEnumError> {
        match v {
            "MODE" => Ok(EnumMultivariateAggregation::Mode),
            v => v.parse().map(|v| EnumMultivariateAggregation::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for EnumMultivariateAggregation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<EnumMultivariateAggregation, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the EnumMultivariateAggregation enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
